import React, { useState } from 'react';
import SuiSwitch from '@s-ui/react-atom-switch';
import IconAccordion from './iconAccordion';
export default function GroupItem(_ref) {
  var onItemChange = _ref.onItemChange,
      baseClass = _ref.baseClass,
      itemInfo = _ref.itemInfo,
      itemValue = _ref.itemValue,
      vendorList = _ref.vendorList,
      i18n = _ref.i18n;

  var _useState = useState(false),
      expanded = _useState[0],
      setExpanded = _useState[1];

  var handleItemClick = function handleItemClick() {
    setExpanded(!expanded);
  };

  var PolicyUrl = function PolicyUrl() {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.POLICY_URL), /*#__PURE__*/React.createElement("a", {
      className: baseClass + "-text " + baseClass + "-text--expanded",
      href: itemInfo.policyUrl,
      target: "_blank",
      rel: "noopener noreferrer"
    }, itemInfo.policyUrl));
  };

  var Information = function Information(_ref2) {
    var purposeIds = _ref2.purposeIds,
        vendorList = _ref2.vendorList;
    return purposeIds.map(function (id) {
      var _vendorList$id, _vendorList$id2;

      return /*#__PURE__*/React.createElement("div", {
        key: id + "-purposes",
        className: baseClass + "-paragraph"
      }, /*#__PURE__*/React.createElement("p", {
        className: baseClass + "-text " + baseClass + "-text--expanded"
      }, /*#__PURE__*/React.createElement("strong", null, vendorList && ((_vendorList$id = vendorList[id]) == null ? void 0 : _vendorList$id.name) + ": ")), /*#__PURE__*/React.createElement("p", {
        className: baseClass + "-text " + baseClass + "-text--expanded"
      }, vendorList && ((_vendorList$id2 = vendorList[id]) == null ? void 0 : _vendorList$id2.description)));
    });
  };

  var ExpandedContent = function ExpandedContent() {
    var _itemInfo$purposes, _itemInfo$purposes2, _itemInfo$legIntPurpo, _itemInfo$specialPurp, _itemInfo$specialPurp2, _itemInfo$features, _itemInfo$features2, _itemInfo$specialFeat, _itemInfo$specialFeat2;

    return /*#__PURE__*/React.createElement(React.Fragment, null, itemInfo.policyUrl && /*#__PURE__*/React.createElement(PolicyUrl, null), !!((_itemInfo$purposes = itemInfo.purposes) == null ? void 0 : _itemInfo$purposes.length) && vendorList.purposes && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.PURPOSES), !!((_itemInfo$purposes2 = itemInfo.purposes) == null ? void 0 : _itemInfo$purposes2.length) && vendorList.purposes && /*#__PURE__*/React.createElement(Information, {
      purposeIds: itemInfo.purposes,
      vendorList: vendorList.purposes
    }), !!itemInfo.legIntPurposes.length && vendorList.purposes && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.LEGITIMATE_INTEREST_PURPOSES), !!((_itemInfo$legIntPurpo = itemInfo.legIntPurposes) == null ? void 0 : _itemInfo$legIntPurpo.length) && vendorList.purposes && /*#__PURE__*/React.createElement(Information, {
      purposeIds: itemInfo.legIntPurposes,
      vendorList: vendorList.purposes
    }), !!((_itemInfo$specialPurp = itemInfo.specialPurposes) == null ? void 0 : _itemInfo$specialPurp.length) && vendorList.specialPurposes && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.SPECIAL_PURPOSES), !!((_itemInfo$specialPurp2 = itemInfo.specialPurposes) == null ? void 0 : _itemInfo$specialPurp2.length) && vendorList.specialPurposes && /*#__PURE__*/React.createElement(Information, {
      purposeIds: itemInfo.specialPurposes,
      vendorList: vendorList.specialPurposes
    }), !!((_itemInfo$features = itemInfo.features) == null ? void 0 : _itemInfo$features.length) && vendorList.features && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.FEATURES), !!((_itemInfo$features2 = itemInfo.features) == null ? void 0 : _itemInfo$features2.length) && vendorList.features && /*#__PURE__*/React.createElement(Information, {
      featureIds: itemInfo.features,
      vendorList: vendorList.features
    }), !!((_itemInfo$specialFeat = itemInfo.specialFeatures) == null ? void 0 : _itemInfo$specialFeat.length) && vendorList.specialFeatures && /*#__PURE__*/React.createElement("h3", null, i18n.VENDOR_PAGE.GROUPS.EXPANDED.SPECIAL_FEATURES), !!((_itemInfo$specialFeat2 = itemInfo.specialFeatures) == null ? void 0 : _itemInfo$specialFeat2.length) && vendorList.specialFeatures && /*#__PURE__*/React.createElement(Information, {
      featureIds: itemInfo.specialFeatures,
      vendorList: vendorList.specialFeatures
    }));
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container"
  }, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container-clicklable",
    onClick: handleItemClick
  }, /*#__PURE__*/React.createElement(IconAccordion, {
    baseClass: expanded ? baseClass + "-icon-accordion " + baseClass + "-icon-accordion--expanded" : baseClass + "-icon-accordion"
  }), /*#__PURE__*/React.createElement("p", {
    className: baseClass + "-text"
  }, itemInfo.name)), /*#__PURE__*/React.createElement(SuiSwitch, {
    type: "single",
    name: "groupItem",
    value: itemValue,
    onToggle: function onToggle() {
      return onItemChange(itemValue);
    }
  })), expanded && /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-container--expanded"
  }, /*#__PURE__*/React.createElement(ExpandedContent, null)));
}