import React from 'react';
import SuiButton from '@s-ui/react-atom-button';
import GroupItem from './GroupItem';
export default function PurposeGroup(_ref) {
  var name = _ref.name,
      i18n = _ref.i18n,
      baseClass = _ref.baseClass,
      descriptions = _ref.descriptions,
      state = _ref.state,
      onConsentsChange = _ref.onConsentsChange,
      onAcceptAll = _ref.onAcceptAll,
      onRejectAll = _ref.onRejectAll,
      vendorList = _ref.vendorList;
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-title-container"
  }, /*#__PURE__*/React.createElement("h2", {
    className: baseClass + "-title"
  }, name), /*#__PURE__*/React.createElement("div", {
    className: baseClass + "-buttons"
  }, /*#__PURE__*/React.createElement(SuiButton, {
    size: "small",
    design: "outline",
    onClick: onRejectAll
  }, i18n.DISABLE_BUTTON), /*#__PURE__*/React.createElement(SuiButton, {
    size: "small",
    onClick: onAcceptAll
  }, i18n.ENABLE_BUTTON))), state && descriptions && Object.keys(descriptions).map(function (key, index) {
    return /*#__PURE__*/React.createElement(GroupItem, {
      key: key + "-" + index,
      baseClass: baseClass + "-item",
      itemInfo: descriptions[key],
      itemValue: state.consents[key],
      i18n: i18n,
      vendorList: vendorList,
      onItemChange: function onItemChange(value) {
        return onConsentsChange({
          index: key,
          value: value
        });
      }
    });
  }));
}