import _extends from "@babel/runtime/helpers/esm/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect } from 'react';
import SuiModal from '@s-ui/react-molecule-modal';
import SuiButton from '@s-ui/react-atom-button';
import IconClose from './components/IconClose';
import PurposeGroup from './components/PurposeGroup';
import { I18N } from './settings';
var CLASS = 'sui-TcfSecondLayer';
export default function TcfSecondLayer(_ref) {
  var isMobile = _ref.isMobile,
      _ref$lang = _ref.lang,
      lang = _ref$lang === void 0 ? 'es' : _ref$lang,
      logo = _ref.logo,
      loadUserConsent = _ref.loadUserConsent,
      saveUserConsent = _ref.saveUserConsent,
      getVendorList = _ref.getVendorList,
      uiVisible = _ref.uiVisible,
      onGoBack = _ref.onGoBack;

  var _useState = useState(null),
      state = _useState[0],
      setState = _useState[1];

  var _useState2 = useState(true),
      modalOpen = _useState2[0],
      setModalOpen = _useState2[1];

  var _useState3 = useState(null),
      vendorListState = _useState3[0],
      setVendorListState = _useState3[1];

  var i18n = I18N[lang];
  useEffect(function () {
    var getVendorListAndConsent = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var _yield$getVendorList, purposes, specialPurposes, features, specialFeatures, vendors, _yield$loadUserConsen, vendor, isNew, vendorsConsent;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return getVendorList({
                  language: lang
                });

              case 2:
                _yield$getVendorList = _context.sent;
                purposes = _yield$getVendorList.purposes;
                specialPurposes = _yield$getVendorList.specialPurposes;
                features = _yield$getVendorList.features;
                specialFeatures = _yield$getVendorList.specialFeatures;
                vendors = _yield$getVendorList.vendors;
                setVendorListState({
                  purposes: purposes,
                  specialPurposes: specialPurposes,
                  features: features,
                  specialFeatures: specialFeatures,
                  vendors: vendors
                });
                _context.next = 11;
                return loadUserConsent();

              case 11:
                _yield$loadUserConsen = _context.sent;
                vendor = _yield$loadUserConsen.vendor;
                isNew = _yield$loadUserConsen.isNew;
                vendorsConsent = vendor;

                if (isNew) {
                  vendorsConsent.consents = format({
                    reference: vendors,
                    object: {},
                    value: true
                  });
                }

                setState({
                  vendors: vendorsConsent
                });

              case 17:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function getVendorListAndConsent() {
        return _ref2.apply(this, arguments);
      };
    }();

    getVendorListAndConsent();
  }, [getVendorList, loadUserConsent, lang]);

  var handleCloseModal = function handleCloseModal() {
    uiVisible({
      visible: false
    });
    setModalOpen(false);
  };

  var format = function format(_ref3) {
    var reference = _ref3.reference,
        object = _ref3.object,
        _ref3$value = _ref3.value,
        value = _ref3$value === void 0 ? false : _ref3$value;
    Object.keys(reference).forEach(function (key) {
      if (!object[key]) {
        object[key] = value;
      }
    });
    return object;
  };

  var formatConsentObject = function formatConsentObject(_ref4) {
    var _ref4$vendor = _ref4.vendor,
        vendor = _ref4$vendor === void 0 ? {} : _ref4$vendor;
    vendor.consents = format({
      reference: vendorListState.vendors || {},
      object: vendor.consents || {}
    });
    return {
      vendor: vendor
    };
  };

  var handleSaveExitClick = function handleSaveExitClick() {
    saveUserConsent(formatConsentObject({
      vendor: state.vendors
    }));
    uiVisible({
      visible: false
    });
    setModalOpen(false);
  };

  var changeAllGroup = function changeAllGroup(_ref5) {
    var group = _ref5.group,
        value = _ref5.value;
    setState(function (prevState) {
      var _extends2;

      for (var key in vendorListState[group]) {
        prevState[group].consents[key] = value;
      }

      return _extends({}, prevState, (_extends2 = {}, _extends2[group] = prevState[group], _extends2));
    });
  };

  var handleRejectAll = function handleRejectAll(_ref6) {
    var group = _ref6.group;
    changeAllGroup({
      group: group,
      value: false
    });
  };

  var handleAcceptAll = function handleAcceptAll(_ref7) {
    var group = _ref7.group;
    changeAllGroup({
      group: group,
      value: true
    });
  };

  var handleVendorsConsentsChange = function handleVendorsConsentsChange(_ref8) {
    var index = _ref8.index,
        value = _ref8.value;
    setState(function (prevState) {
      var vendors = prevState.vendors;
      var consents = vendors.consents;
      consents[index] = !value;
      return _extends({}, prevState, {
        vendors: _extends({}, prevState.vendors, {
          consents: consents
        })
      });
    });
  };

  var Logo = function Logo() {
    return /*#__PURE__*/React.createElement("img", {
      className: isMobile ? CLASS + "-logo" : CLASS + "-logo " + CLASS + "-logo--desktop",
      src: logo,
      alt: "logo"
    });
  };

  return /*#__PURE__*/React.createElement("div", {
    className: CLASS
  }, /*#__PURE__*/React.createElement(SuiModal, {
    isOpen: modalOpen,
    closeOnOutsideClick: true,
    closeOnEscKeyDown: true,
    header: isMobile ? /*#__PURE__*/React.createElement(Logo, null) : false,
    iconClose: isMobile ? /*#__PURE__*/React.createElement(IconClose, null) : false,
    onClose: handleCloseModal,
    fitContent: true
  }, !isMobile && /*#__PURE__*/React.createElement(Logo, null), /*#__PURE__*/React.createElement("div", {
    className: isMobile ? CLASS + "-container" : CLASS + "-container " + CLASS + "-container--desktop"
  }, /*#__PURE__*/React.createElement("h2", {
    className: isMobile ? CLASS + "-title" : CLASS + "-title " + CLASS + "-title--desktop"
  }, i18n.VENDOR_PAGE.TITLE), /*#__PURE__*/React.createElement("p", {
    className: isMobile ? CLASS + "-text" : CLASS + "-text " + CLASS + "-text--desktop"
  }, i18n.VENDOR_PAGE.TEXT), (state == null ? void 0 : state.vendors) && (vendorListState == null ? void 0 : vendorListState.vendors) && /*#__PURE__*/React.createElement(PurposeGroup, {
    name: i18n.VENDOR_PAGE.GROUPS.TITLE,
    baseClass: CLASS + "-group",
    descriptions: vendorListState.vendors,
    state: state.vendors,
    onConsentsChange: handleVendorsConsentsChange,
    i18n: i18n,
    onAcceptAll: function onAcceptAll() {
      return handleAcceptAll({
        group: 'vendors'
      });
    },
    onRejectAll: function onRejectAll() {
      return handleRejectAll({
        group: 'vendors'
      });
    },
    vendorList: vendorListState
  })), /*#__PURE__*/React.createElement("footer", {
    className: CLASS + "-buttons"
  }, /*#__PURE__*/React.createElement(SuiButton, {
    design: "outline",
    onClick: onGoBack
  }, i18n.GO_BACK_BUTTON), /*#__PURE__*/React.createElement(SuiButton, {
    onClick: handleSaveExitClick
  }, i18n.ACCEPT_BUTTON))));
}
TcfSecondLayer.displayName = 'TcfSecondLayer';